/* This file is part of the KDE project
   Copyright (C) 1998, 1999 Torben Weis <weis@kde.org>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
 
   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/     

#ifndef __main_h__
#define __main_h__

#include "signals.h"

#include <komBase.h>

class Sender : virtual public KOMBase,
	       virtual public Signals::Sender_skel
{
public:
  Sender();
  virtual ~Sender();
  
  virtual void clicked();
  virtual void text( const char* message );
  virtual void birthday( const Signals::Birthday& bday );

};

class Receiver : virtual public KOMBase,
		 virtual public Signals::Receiver_skel
{
public:
  Receiver();
  virtual ~Receiver();
  
  virtual void slotClicked();
  virtual void slotText( const char* message );
  virtual void slotBirthday( const Signals::Birthday& bday );
};

#endif
